#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>
#include <sstream>
#include <string>
using namespace std;


struct Input
{
    vector<double> numbers;
    size_t bin_count{};
    size_t number_count{};
    size_t max_count{};
};

Input
input_data(istream& stream, bool prompt)
{
    size_t number_count;
    if (prompt==true)
    {
        cerr << "Enter number count: ";
    }
    stream >> number_count;
    Input in;
    if (prompt==true)
    {
        cerr << "Enter bin count: ";
    }
    stream >> in.bin_count;

    vector<double> numbers(in.number_count);
    in.numbers.resize(in.number_count);
    for (size_t i = 0; i < in.number_count; i++)
    {
        stream >> in.numbers[i];
    }
    size_t bin_count;
    size_t max_count;
    in.max_count = 0;
    return in;
}
size_t write_data(void* items, size_t item_size, size_t item_count, void* ctx)
{
    size_t data_size = item_size * item_count;
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    auto text = reinterpret_cast<const char*>(items);
    buffer->write(text, data_size);
    return data_size;
}
Input download(const string& address)
{

    stringstream buffer;
    curl_global_init(CURL_GLOBAL_ALL);
    CURL* curl = curl_easy_init();
    if(curl)
    {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);
        curl_easy_cleanup(curl);
        if (res != 0)
        {
            cout << res;
            exit(1);
        }
        curl_version_info_data *curl_info = curl_version_info(CURLVERSION_NOW);
        for (size_t i = 0; curl_info->protocols != NULL; i++){
                cerr << curl_info->protocols[i] << "\n";
    }
    curl_global_init(CURL_GLOBAL_ALL);
      return input_data(buffer, false);
}
}

int main(int argc, char* argv[]){

    Input in;
    if (argc > 1) {
        in = download(argv[1]);
    } else {
        in = input_data(cin, true);
    }
auto bins = make_histogram(in.numbers, in.bin_count, in.number_count, in.max_count);
vector<double> test;
show_histogram_svg(bins, in.max_count, in.bin_count, test);
return 0;
}
